//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "cppbsmp.h"
#include "dstring.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VBMCOM32Lib_TLB"
#pragma link "VBMCOM32Lib_OCX"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  short rc;

//  Com1->VcDebugTrace = VARIANT_TRUE;
  rc = Com1->OpenComm();
  if(rc)
  {
    char szMsg[128];
    wsprintf(szMsg,"Com1 open error %d",rc);
    MessageBox(NULL,szMsg,"error",MB_OK);
    return;
  }

//  Com2->VcDebugTrace = VARIANT_TRUE;
  rc = Com2->OpenComm();
  if(rc)
  {
    char szMsg[128];
    wsprintf(szMsg,"Com2 open error %d",rc);
    MessageBox(NULL,szMsg,"error",MB_OK);
    return;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnSendStringClick(TObject *Sender)
{
  short rc;
  BSTR  bstr;

  bstr = SysAllocString(L"this is test");

  rc = Com1->SendString(bstr);
  if (rc)
  {
    char szMsg[128];
    wsprintf(szMsg,"SendString Error %d",rc);
    MessageBox(NULL,szMsg,"error",MB_OK);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnRecvStringClick(TObject *Sender)
{
  BSTR bstr;
  char szMsg[256];

  bstr = Com2->RecvString(0);

  if( bstr != NULL && SysStringLen(bstr) )
  {
    AnsiString tmp;
    // convert to AnsiString
    tmp = WideCharToString(bstr);
    wsprintf(szMsg,"received = %s",tmp.c_str());
    MessageBox(NULL,szMsg,"received",MB_OK);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Destroy(TObject *Sender)
{
  Com1->CloseComm();
  Com2->CloseComm();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnSendBinaryClick(TObject *Sender)
{
  short rc;
  Variant v;
  int i;
  int Bounds[2];

  Bounds[0] = 0;
  Bounds[1] = 255;
  v = VarArrayCreate( Bounds, 1, varByte );
  for(i=0; i <= 255; i++)
  {
    Variant vTmp = Byte(i);
    v.PutElement(vTmp,i);
  }

  rc = Com1->SendBinaryBytes(v);
  if (rc)
  {
    char szMsg[128];
    wsprintf(szMsg,"SendBinaryBytes error %d",rc);
    MessageBox(NULL,szMsg,"error",MB_OK);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnRecvBinaryClick(TObject *Sender)
{
  short rc;
  short n;
  char szTmp[128];
  int i;
  Variant v;
  VARIANT vNoParam;
  int Bounds[2];

  Bounds[0] = 0;
  Bounds[1] = 255;
  v = VarArrayCreate( Bounds, 1, varByte );

  // p[^ȗVARIANT^̍쐬@Tv
  vNoParam.vt = VT_ERROR;
  vNoParam.scode = DISP_E_PARAMNOTFOUND;

  rc = Com2->RecvBinaryBytes(v,vNoParam);
  if( rc )
  {
    char szMsg[128];
    wsprintf(szMsg,"Recv Error %d\n",rc);
    MessageBox(NULL,szMsg,"error",MB_OK);
  }

  for (i=0; i <= 255; i++)
  {
    n = v.GetElement(i);
    wsprintf(szTmp,"%d",n);
    ListBox1->Items->Add(szTmp);
  }
}
//---------------------------------------------------------------------------

